package de.oceanCLeV.derp.client;

import com.google.gson.Gson;
import com.google.gson.JsonObject;
import net.fabricmc.api.ClientModInitializer;
import de.oceanCLeV.derp.client.features.CheatDetector;
import de.oceanCLeV.derp.client.features.Zoom;
import net.fabricmc.fabric.api.client.event.lifecycle.v1.ClientTickEvents;
import net.fabricmc.fabric.api.client.keybinding.v1.KeyBindingHelper;
import net.minecraft.client.option.KeyBinding;
import net.minecraft.client.util.InputUtil;
import org.lwjgl.glfw.GLFW;

import java.io.*;
import java.net.URI;
import java.net.http.HttpClient;
import java.net.http.HttpRequest;
import java.net.http.HttpResponse;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.nio.file.Files;
import java.nio.file.Path;

public class DerpClient implements ClientModInitializer {
    @Override
    public void onInitializeClient() {
        System.out.println("DerpClient Init Process started!");

        KeyBinding somerandombttn = KeyBindingHelper.registerKeyBinding(new KeyBinding(
                "key.derpclient.something",
                InputUtil.Type.KEYSYM,
                GLFW.GLFW_KEY_Y,
                "category.derpclient.main"
        ));
        CheatDetector.checkForCheats();
        Zoom.init();

        sendStartupData();

        System.out.println("Welcome!");

        ClientTickEvents.START_CLIENT_TICK.register(client -> {
            if (client.getWindow() != null) {
                client.getWindow().setTitle("DerpClient 1.0 DEV-Beta");
            }
            Zoom.zoom(client);
        });
    }

    private void sendStartupData() {
        try {
            String username = net.minecraft.client.MinecraftClient.getInstance().getSession().getUsername();
            String currentTime = LocalDateTime.now().format(DateTimeFormatter.ISO_LOCAL_DATE_TIME);

            JsonObject jsonData = new JsonObject();
            jsonData.addProperty("nick", username);
            jsonData.addProperty("last_time_online", currentTime);
            jsonData.addProperty("online", true);
            jsonData.addProperty("server", "N/A");

            HttpClient client = HttpClient.newHttpClient();
            HttpRequest request = HttpRequest.newBuilder()
                    .uri(URI.create("https://axiom-mc.org/derpclient/api.php"))
                    .header("Content-Type", "application/json")
                    .POST(HttpRequest.BodyPublishers.ofString(jsonData.toString()))
                    .build();

            HttpResponse<String> response = client.send(request, HttpResponse.BodyHandlers.ofString());

            JsonObject responseJson = new Gson().fromJson(response.body(), JsonObject.class);
            String token = responseJson.get("token").getAsString();

            File configDir = new File("config");
            configDir.mkdirs();

            JsonObject tokenJson = new JsonObject();
            tokenJson.addProperty("token", token);
            Files.writeString(Path.of("config/do-not-share-this-private-token.json"), tokenJson.toString());

        } catch (Exception e) {
            System.out.println("Failed to send startup data: " + e.getMessage());
        }
    }
}